unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Perlin;

type
  TPixel = array [1..3] of Byte;

  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    ScrollBar2: TScrollBar;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Label4: TLabel;
    RadioGroup2: TRadioGroup;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Bitmap: TBitmap;
  Noise: TPerlinNoise2D;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Bitmap := TBitmap.Create;
  Bitmap.Width := 256;
  Bitmap.Height := 256;
  Bitmap.PixelFormat := pf24bit;

  Noise := TPerlinNoise2D.Create;
  Noise.Persistence := 0.6;
  Noise.Seed := 12345;
  Noise.Depth := 8;
  Noise.SetAmplitude(0, 255);
  Noise.Frequency := 0.01;
  Noise.FrequencyFactor := 2;
  Noise.Size := 256;

  Noise.SetValues;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Bitmap.Free;
  Noise.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i, j: integer;
  p: ^TPixel;
  Value : Byte;
begin
  Noise.Calculate;
  for i := 0 to 255 do
  begin
    p := Bitmap.ScanLine[i];
    for j := 0 to 255 do
    begin
      Value := Round(Noise.GetValue(i,j));
      p^[1] := Value;
      p^[2] := Value;
      p^[3] := Value;
      inc(p);
    end;
  end;
  PaintBox1.Canvas.Draw(0,0,Bitmap);
end;

end.
